<template>
  <div>
    <h2 id="page-heading" data-cy="CooperativeHeading">
      <span v-text="$t('coopcycleApp.cooperative.home.title')" id="cooperative-heading">Cooperatives</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('coopcycleApp.cooperative.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'CooperativeCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-cooperative"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('coopcycleApp.cooperative.home.createLabel')"> Create a new Cooperative </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && cooperatives && cooperatives.length === 0">
      <span v-text="$t('coopcycleApp.cooperative.home.notFound')">No cooperatives found</span>
    </div>
    <div class="table-responsive" v-if="cooperatives && cooperatives.length > 0">
      <table class="table table-striped" aria-describedby="cooperatives">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('directeur')">
              <span v-text="$t('coopcycleApp.cooperative.directeur')">Directeur</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'directeur'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="cooperative in cooperatives" :key="cooperative.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'CooperativeView', params: { cooperativeId: cooperative.id } }">{{ cooperative.id }}</router-link>
            </td>
            <td v-text="$t('coopcycleApp.Role.' + cooperative.directeur)">{{ cooperative.directeur }}</td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'CooperativeView', params: { cooperativeId: cooperative.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'CooperativeEdit', params: { cooperativeId: cooperative.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(cooperative)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="coopcycleApp.cooperative.delete.question" data-cy="cooperativeDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-cooperative-heading" v-text="$t('coopcycleApp.cooperative.delete.question', { id: removeId })">
          Are you sure you want to delete this Cooperative?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-cooperative"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeCooperative()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./cooperative.component.ts"></script>
